<template>
  <single-panel>
    <header class="group-card__header">
      <router-link tag="h1" to="/browser_link__groups">
        <i class="icon chevron-left"></i>
        Группа «{{ $route.query.name }}»
      </router-link>
    </header>
    <div class="content">
      <div class="delete-panel" v-if="selectedAgents.length">
        <span>
          {{ declOfNum(selectedAgents.length, 'Выбрана | Выбрано | Выбрано') }} {{ plural(selectedAgents.length, 'запись | записи | записей') }}
        </span>
        <span class="delete-panel__button" @click="confirmDelete">
          <i class="icon delete"></i>
          Удалить
        </span>
      </div>
      <ob-table
        :columns="agentsColumns"
        :functionalPanel="true"
        :remote-opt="{
          method: getGroupAgents
        }"
        :tableLayoutFixed="false"
        :show-add-button="true"
        add-button-text="Добавить контрагента"
        data-qa="LogisticDomainsGroupAgentsTable"
        ref="obTableAllGroupAgents"
        @add="onAdd"
        @select="onSelect"
        is-fixed-header
      >
      <template slot="checkbox" slot-scope="{ data }">
          <div @click.stop>
            <ob-checkbox
              v-model="data.item.checked"
              @change="toggleAgent(data.item)"
            />
          </div>
        </template>
        <template v-slot:type="{ data }">
          <i :class="['icon', $options.rolesMap[data.item.roleCode]]"></i>
        </template>
        <template v-slot:status="{ data }">
          <div :class="['status', data.item.status === 'онлайн' ? 'is-online' : '']">
            {{data.item.status}}
          </div>
        </template>
        <template v-slot:risk="{ data }">
          <i :class="['icon', $options.riskColorsMap[data.item.riskColor]]"></i>
        </template>
        <template v-slot:linkType="{ data }">
          <div class="link">
            <i :class="['icon', $options.linkTypesMap[data.item.linkType]]"></i>
          </div>
        </template>
        <template v-slot:files="{ data }">
          <div class="link">
            <i class="icon attach"></i>
          </div>
        </template>
        <template v-slot:membershipPeriodTo="{ data }">
          <div data-table-cell-action class="membership-period-cell">
            <ob-datepicker
                v-if="!data.item.noMembershipPeriodTo"
                v-model="data.item.membershipPeriodTo"
                :sinceTo="disabledMembershipDates"
                label=""
                position="bottom-end"
                data-qa="membershipPeriodTo"
                @input="toggleMembershipPeriod(data.item)"
                class="obInputField obDatepickerField"
                :blockDaysBeforeToday="true"
                :isValidDate="data.item.validationError === ''"
                :dateValidationMessage="data.item.validationError"
                :is-validate-immediatly="true"
            />
            <ob-checkbox
                label="Бессрочно"
                v-model="data.item.noMembershipPeriodTo"
                @change="toggleMembershipPeriod(data.item)"
                @click.stop
            />
          </div>
        </template>
        <template slot="noneContent">
          <div class="no-content">
            <p>no content</p>
          </div>
        </template>
      </ob-table>
    </div>

    <ob-modal
      ref="addAgentModal"
      :title="`Добавление контрагента в группу «${this.$route.query.name}»`"
      :is-show-controls="false"      
      size="max"
      @opened="onOpened"
    >
      <AgentModal
        ref="addModal"
        :agentsToFilter="agentsToFilter"
        @submitted="onSubmittedForm"
        :data-source="newAgents"
      />
    </ob-modal>

    <ob-modal
      ref="agentModal"
      size="medium"
      isShowControls
      okText="Выбрать"
      :isSubmitDisabled="activeTableAgent && activeTableAgent.checked"
      @submit="onSelectAgent"
      cancelText="Отменить"
    >
      <div class="title" slot="title" v-if="activeAgent">
        <div class="title__second">
          экспедитор
          <span :class="['status', activeAgent.status === 'онлайн' ? 'is-online' : '']">
            {{activeAgent.status}}
          </span>
        </div>
        <div class="ob-ty-modal-title">
          <i :class="['icon', $options.rolesMap[activeAgent.roleCode]]"></i>
          {{activeAgent.title}}
        </div>
      </div>
      <agent-info
        :agent="activeAgent"
      />
    </ob-modal>

    <ob-modal
      ref="deleteAgentsModal"
      title="Удаление контрагентов из группы"
      size="medium"
      :is-show-controls="true"
      isError
      ok-text="Удалить"
      @submit="onDeleteGroupAgents"
    >
      Вы точно хотите удалить {{ plural(selectedAgents.length, 'контрагента | контрагентов | контрагентов') }}? 
    </ob-modal>
  </single-panel>
</template>

<script>
  import moment from "moment";
  import api from '@/api';
  import SinglePanel from "common-components/src/obComponents/obSinglePanels";
  import ObTable from "common-components/src/obComponents/obTable";
  import ObModal from "common-components/src/obComponents/obModal";
  import AgentModal from "./components/addAgentModal";
  import AgentInfo from "./components/agentInfo";
  import ObCheckbox from "common-components/src/obComponents/obCheckbox";
  import ObDatepicker from 'common-components/src/obComponents/obDatePickerConstructor'
  export default {
    name: 'logisticDomainsGroupAgents',
    
    rolesMap: {
      'CLIENT': 'role-client',
      'CLICAR': 'role-domain-owner',
      'CARRIER': 'role-agent'
    },

    riskColorsMap: {
      'GREEN': 'risk-1-blue',
      'BLUE': 'risk-2-green',
      'YELLOW': 'risk-3-yellow',
      'ORANGE': 'risk-4-orange',
      'RED': 'risk-5-red',
      'BLACK': 'risk-6-black'
    },

    linkTypesMap: {
      "HANDSHAKE": 'handshake',
      "CONTRACT": 'document',
      "VAN": 'close'
    },

    components: {
      SinglePanel,
      ObTable,
      ObModal,
      AgentModal,
      AgentInfo,
      ObCheckbox,
      ObDatepicker,
    },

    data() {
      return {
        newAgents: {
          agents: []
        },
        activeAgent: null,
        activeTableAgent: null,
        selectedAgents: [],
        agentsToFilter: []
      }
    },

    computed: {
      agentsColumns() {
        return [
          {
            title: '',
            slotName: 'checkbox',
            isToggleDisabled: true
          },
          {
            title: 'Тип',
            key: 'roleCode',
            slotName: 'type'
          },
          {
            title: 'название контрагента',
            key: 'title',
          },
          {
            title: 'присутствие в системе',
            key: 'status',
            slotName: 'status'
          },
          {
            title: 'группа риска',
            key: 'riskColor',
            slotName: 'risk'
          },
          {
            title: 'рейтинг',
            key: 'rating'
          },
          {
            title: 'скоринг',
            key: 'scoring'
          },
          {
            title: 'тип линка',
            key: 'linkType',
            slotName: 'linkType'
          },
          {
            title: 'инн',
            key: 'inn'
          },
          {
            title: 'телефон',
            key: 'phone'
          },
          {
            title: 'эл. почта',
            key: 'email'
          },
          {
            title: 'юридический адрес',
            key: 'legalAddress'
          },
          {
            title: 'описание',
            key: 'description'
          },
          {
            title: 'files',
            slotName: 'files'
          },
          {
            title: 'Период членства в группе, до',
            slotName: 'membershipPeriodTo',
            width: 250
          }
        ]
      },
      disabledMembershipDates() {
        return [
          {
            from: new Date(1976, 0, 0),
            to: moment().add(-1, 'day')
          }
        ]
      },
    },

    methods: {
      onOpened() {
        this.$nextTick(() => {
          this.$refs.addModal.init();
        })
      },

      onSelectAgent() {
        this.activeTableAgent.checked=true;
        this.toggleAgent(this.activeTableAgent);
        this.$refs.agentModal.close();
      },

      async onSubmittedForm($event) {
        const payload = $event.map(item => item.uuid);
        try {
          await api.linkBrowser.addGroupAgent(this.$route.params.id, payload);
          this.$refs.addAgentModal.close();
          this.$refs['obTableAllGroupAgents'].loadData({ init: true });
        } catch (err) {
          console.error(err);
        }
      },
      async getGroupAgents({page, size, sort="title,desc", query}) {
        const altSort = sort?.split(',')
        try {
          let res = await api.linkBrowser.getGroupAgents(this.$route.params.id, {page, size, sort: altSort[0], direction: altSort[1].toUpperCase(), query});
          res.content = res.content.map(item => {
            return {
              ...item,
              status: '—',
              description: '—',
              checked: false,
              noMembershipPeriodTo: !item.membershipPeriodTo,
              membershipPeriodTo: item.membershipPeriodTo || new Date(),
              validationError: ''
            }
          })
          this.agentsToFilter = res.content.map(item => item.uuid);
          return res;
        } catch (err) {
          console.error(err);
        }
      },

      async onAdd() {
        this.$refs.addAgentModal.open();
      },

      async onSelect(agent) {
        this.activeTableAgent = agent;
        await this.getAgent(agent.uuid);
        this.$refs.agentModal.open();
      },

      async getAgent(uuid) {
        const res = await api.linkBrowser.getAgent(uuid);
        res.status = 'онлайн';
        this.activeAgent = res;
      },

      toggleAgent(agent) {
        if (agent.checked) {
          this.selectedAgents.push(agent);
        } else {
          if (this.selectedAgents.some(item => item.uuid === agent.uuid)) {
            const target = this.selectedAgents.indexOf(agent);
            this.selectedAgents.splice(target, 1);
          }
        }
      },

      confirmDelete() {
        this.$refs.deleteAgentsModal.open();
      },

      async onDeleteGroupAgents() {
        const payload = this.selectedAgents.map(item => item.uuid);
        try {
          await api.linkBrowser.deleteGroupAgent(this.$route.params.id, payload);
          this.selectedAgents = [];
          this.$refs.deleteAgentsModal.close();
          this.$refs['obTableAllGroupAgents'].loadData({ init: true });
        } catch (err) {
          console.error(err);
        }
      },

      plural(value, unit) {
        return `${value} ${this.declOfNum(value, unit)}`;
      },

      declOfNum(n, string) {
        let titles = string.split("|");
        return titles[
          n % 10 == 1 && n % 100 != 11
            ? 0
            : n % 10 >= 2 && n % 10 <= 4 && (n % 100 < 10 || n % 100 >= 20)
            ? 1
            : 2
        ];
      },

      async toggleMembershipPeriod(item) {
        let periodTo = moment(item.membershipPeriodTo);
        let to = moment(this.disabledMembershipDates[0].to)
        if (periodTo.isValid() && periodTo.valueOf() > to.valueOf()) {
          item.validationError = '';
          try {
            await api.linkBrowser.toggleMembershipPeriod({
              group_uuid: this.$route.params.id,
              uuid: item.uuid,
              membershipPeriodTo: item.noMembershipPeriodTo ? null : item.membershipPeriodTo
            })
          } catch (err) {
            console.error(err);
          }
        } else {
          item.validationError = `Дата не должна быть в прошлом`;
        }
      }
    }
  }
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

  ::v-deep {
    .ob-func-panel__controls{
      .ob-func-panel__controls-side:first-child{
        .ob-func-panel__control:nth-child(2){
          display: none;
        }
        .ob-func-panel__control:nth-child(3){
          display: none;
        }
      }
    }
  }

  .left {
    margin: 20px;
  }

  .group-card__header {
    display: flex;
    align-items: center;
    padding: 25px;
    position: relative;
    z-index: 2;
    background-color: #fff;

    i {
      font-size: 16px;
      color: $color-blue-navy-blue;
      position: relative;
      top: -2px;
      margin-right: 10px;
    }
  }

  h1 {
    @include font-mixin(20px, 28px, 700, $style-black);
    cursor: pointer;
  }

  .is-online {
    color: $deep-blue;
  }

  .link {
    color: $color-blue-navy-blue;
  }

  .title {
    i {
      color: $color-blue-smalt;
    }
  }

  .title__second {
    display: flex;

    span {
      margin-left: 10px;
    }
  }

  .no-content {
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;

    p {
      @include font-mixin(24px, 40px, 400, $color-grey-span);
    }

    a {
      margin-top: 20px;
      @include font-mixin(16px, 20px, 400, $color-blue-navy-blue);
      text-decoration: none;
    }
  }

  ::v-deep {
    td {
      white-space: nowrap;
    }

    td:nth-child(7) > .td-container {
      justify-content: center;
    }
  }

  .delete-panel {
    position: absolute;
    left: 0;
    top: 0;
    width: 70%;
    z-index: 1;
    display: flex;
    align-items: center;
    height: 60px;
    padding: 0 21px;
    background: #fff;
    @include font-mixin(16px, 20px, 400, $color-text-base );
  }

  .delete-panel__button {
    display: flex;
    align-items: center;
    margin-left: 12px;
    color: $color-error;
    cursor: pointer;

    i {
      margin-right: 5px;
    }
  }

  .membership-period-cell {
    align-items: center;
    display: flex;
  }
</style>